********************************************************************************
* DESCRIPTION: Master file for Part 1 of GID: Argentina.
*
* AUTHORS: Andres Blanco (University of Michigan),
*          Bernardo Diaz de Astarloa (Universidad de Buenos Aires and Universidad Nacional de La Plata-CEDLAS),
*          Andres Drenik (University of Texas at Austin),
*          Christian Moser (Columbia University and CEPR), and
*          Danilo R. Trupkin (Universidad de Buenos Aires and IIEP, CONICET-UBA).
*
* TIME STAMP: March 26, 2022.
********************************************************************************


********************************************************************************
** Housekeeping ****************************************************************
********************************************************************************
set more off, permanently
clear all
timer clear 1
timer on 1
set seed 1
set rmsg on
set graphics off
postutil clear
cap log close


********************************************************************************
** Macros **********************************************************************
********************************************************************************
* users
if "`c(username)'" == "Roberta" global MAIN_DIR = "C:/Users/Roberta/Dropbox/RA_work_Roberta_Olivieri"
else if "`c(username)'" == "roberta.olivieri" global MAIN_DIR = "C:/Users/roberta.olivieri/Dropbox/RA_work_Roberta_Olivieri"
else if "`c(username)'" == "cm3594" global MAIN_DIR = "/Users/cm3594/Dropbox (CBS)/GID_Argentina/Analysis_randomsample_final"
else if "`c(username)'" == "cmoser" global MAIN_DIR = "/Users/cmoser/Dropbox (CBS)/GID_Argentina/Analysis_randomsample_final"
else {
	disp as error "USER ERROR: Cannot classify current user when defining main directory MAIN_DIR!"
	error 1
}

* directories
global DO_DIR = "${MAIN_DIR}/do"

* programs
do "${DO_DIR}/myprogs.do"
do "${DO_DIR}/myplots.do"


********************************************************************************
** Which sections to run -- change these! **************************************
********************************************************************************
global GID_ARG_Data_Prep_RandomSample = 0 // XXX
global GID_ARG_0_Initialize = 0 // XXX
global GID_ARG_1_Gen_Base_Sample = 0 // XXX
global GID_ARG_2_DescriptiveStats = 0 // XXX
global GID_ARG_3_Inequality = 0 // XXX
global GID_ARG_4_Volatility = 0 // XXX
global GID_ARG_5_Mobility = 0 // XXX
global GID_ARG_6_Insheeting_datasets = 0 // XXX
global GID_ARG_7_Paper_Figs = 0 // XXX


********************************************************************************
** Run sections ****************************************************************
********************************************************************************
if $GID_ARG_Data_Prep_RandomSample do "${DO_DIR}/Data_Prep_RandomSample.do"
if $GID_ARG_0_Initialize do "${DO_DIR}/0_Initialize.do"
if $GID_ARG_1_Gen_Base_Sample do "${DO_DIR}/1_Gen_Base_Sample.do"
if $GID_ARG_2_DescriptiveStats do "${DO_DIR}/2_DescriptiveStats.do"
if $GID_ARG_3_Inequality do "${DO_DIR}/3_Inequality.do"
if $GID_ARG_4_Volatility do "${DO_DIR}/4_Volatility.do"
if $GID_ARG_5_Mobility do "${DO_DIR}/5_Mobility.do"
if $GID_ARG_6_Insheeting_datasets do "${DO_DIR}/6_Insheeting_datasets.do"
if $GID_ARG_7_Paper_Figs do "${DO_DIR}/7_Paper_Figs.do"
