%{
* DESCRIPTION: This code simulates the Calvo-Taylor model for a given set of parameters

* AUTHORS: Andres Blanco (University of Michigan),
*          Bernardo Diaz de Astarloa (Universidad de Buenos Aires and Universidad Nacional de La Plata-CEDLAS),
*          Andres Drenik (University of Texas at Austin),
*          Christian Moser (Columbia University and CEPR), and
*          Danilo R. Trupkin (Universidad de Buenos Aires and IIEP, CONICET-UBA).
*
* TIME STAMP: March 26, 2022.
%}


function calibpar = calibrate(par,shock,d,mom_d,p)

% Define weighting matrix, for now we use identity matrix
GMMweight = eye(size(mom_d,1));

% Define guess and bounds
paramguess = [par.T_taylor;par.sigma_eta;par.w_lb;par.w_ub;par.sigma_phi;par.m_phi;par.sigma_gamma;par.beta];

% Minimize objective function
calibpar   = neldmead_bounds('GMM_objfun',paramguess,p.paramlb,p.paramub,d,mom_d,GMMweight,shock,p);

end
