
qui by new_id: replace w_t=. if _N<=2*$mk_l
 
qui by new_id:  gen period_in=_n


********************************************************************************
*********  Generate non-missing sample between l+1<=t<=T-l            **********
********************************************************************************

display("generate non-missing sample variable h(t)")

qui by new_id: gen h_t=0 if period_in>=$mk_l+1 & period_in<=_N-$mk_l & w_t!=.
 
foreach ii of numlist 0[1]$mk_l {

	qui by new_id: replace h_t=h_t+(l`ii'.w_t~=.) if h_t~=.

}
 
foreach ii of numlist 1[1]$mk_l {

	qui by new_id: replace h_t=h_t+(f`ii'.w_t~=.) if h_t~=.

}

qui replace h_t=h_t/(2*$mk_l)>=$mk_a if h_t~=.


********************************************************************************
*********      Generate the mode in a rolling window             ***************
********************************************************************************

display("generate mode in rolling window")

qui gen w_m       =.

local mk_l_aux=2*$mk_l

display("Percentage finish")
 
foreach ii of numlist 0[1]`mk_l_aux' {

	display(`ii'/`mk_l_aux'*100 )
    qui gsort new_id date
	qui by new_id: gen group_m=ceil((_n-`ii')/(2*$mk_l +1))

	qui gegen new_id_aux=group(new_id group_m)
	
	qui gsort new_id_aux date
	qui by new_id_aux: egen w_m_aux   =mode(w_t)   if   group_m>=1
	by new_id_aux: replace w_m    =w_m_aux  if h_t==1 & $mk_l+1==_n & w_m_aux~=.
	 
	qui drop w_m_aux group_m new_id_aux 
}

qui gsort new_id date
qui drop h_t


 
********************************************************************************
*********      Generate the ht if non-missing and equal to mode       **********
********************************************************************************

display("generate equal values to mode f(t)")

qui by new_id: gen h_t=0 if period_in>=$mk_l +1 & period_in<=_N-$mk_l

foreach ii of numlist 0[1]$mk_l {

	qui by new_id: replace h_t=h_t+(l`ii'.w_t~=.)*(l`ii'.w_t==w_m) if h_t~=. & w_m~=.

}
  
foreach ii of numlist 1/$mk_l {

	qui by new_id: replace h_t=h_t+(f`ii'.w_t~=.)*(f`ii'.w_t==w_m) if h_t~=. & w_m~=.

}
 
qui replace h_t=h_t/(2*$mk_l)>=$mk_c if h_t~=.
drop period_in 
   

********************************************************************************
*********      Generate the regular price with price changes         **********
********************************************************************************

display("generate regular price change")
 
qui by new_id: gen w_r=w_m if h_t==1 & w_m~=. & _N>=(2*$mk_l +1) & _n==$mk_l +1
qui by new_id: replace w_r=w_t if w_r==. & _N>=(2*$mk_l +1) & _n==$mk_l +1

qui gen ind_aux=w_m~=. & w_m==w_t & h_t==1 &_N>=(2*$mk_l +1) & _n>$mk_l +1 

qui replace w_m=-1 if w_m==.
 
qui by new_id: replace w_r=ind_aux*w_m+(1-ind_aux)*w_r[_n-1] if  _n>$mk_l +1 & _N-$mk_l

qui drop ind_aux h_t
  
********************************************************************************
*********      Generate the regular price without v-shape and sales      *******
********************************************************************************

display("generate regular price change without v-shapes")

gen R=.
gen C=.
gen P=.

forv i = 1/5{

qui by new_id: replace R =(w_r~=l.w_r  )   if w_r~=. & l.w_r~=.
qui by new_id: replace C =(w_r==w_t    )   if w_r~=. & w_t~=.
qui by new_id: replace P =(l.w_r==l.w_t)   if l.w_r~=. & l.w_t~=.  
qui by new_id: replace P =0                if P==1 & C==1 & R==1  

replace w_r = f.w_t if f.R*f.C==1  
replace w_r = l.w_t if R*P==1  

}

drop R C P w_m
