 /*
 keep cuil_trab cuit_empl date new_id w_t
 drop regL0 regL1 regL2 regL3 regL4 regL5 regL6 regL7 regL8 var0 var1 var2 var3 temp temp2 tempcost minfut maxfut rule3 rule4
 */
* Nakamura and Steinsson filter by the authors
*global ns_l = 3      	// number of months wages must be stable for unsymmetric v shaped
*global ns_j = 6   		// number of months that can take for the wage to return to it's reference value
 
 *local wind= 3 (This is the L parameter in the slides)
global wind     = $ns_l
*This gives window for rule 2 (This is the J parameter in the slides)
global longwind =$ns_j
*This gives number of periods of recursion
*Runwind has to do with how the program is written as opposed to being one of the parameters: The program runs by calculating a "temporary" regular price `runwind' periods ago for each t, and then iterating forward.  The eventual regular price (filter) equals the "temporary" regular price for the current period
global runwind  = $longwind

*This gives the variables minus 1
global wind1 = $wind-1
global runwind1 = $runwind -1
global longwind1= $longwind -1

*Initialize the reg wages for the periods of recursion: these variables are over J and enter in step 2
foreach num of numlist 0(1)$runwind {
gen regL`num'=.
}

*Initialize the temporary variables: these temporal variables are over L and are in step 3 and 4
foreach num of numlist 0(1)$wind {
gen var`num' =.
}

gen temp=.
gen temp2=.
gen tempcost=.
gen minfut=.
gen maxfut=.

*********************************************************
*Start filter
*Create new series for regular wages

************
*Start with wages `runwind' periods ago
/* Question: Here is over J no L, why? */ 
replace tempcost = L$runwind.w_t 												

foreach num of numlist 0(1)$wind  {
by new_id: replace var`num' = F`num'.tempcost
}


* Step 3: check if there are only <=2 values in in {w_{t-J},w_{t-J+1},w_{t-J+2},w_{t-J+3}}
gen rule3=0
foreach name of varlist var* { 
drop minfut maxfut
egen minfut = rmin(var*)
egen  maxfut = rmax(var*)
replace rule3=1 if `name'~= minfut & `name'~= maxfut 
}
drop maxfut
* generate w_t+J^aux if if there are more than 3 values in t+J
replace regL$runwind  = tempcost if rule3==1
 
 
* Step 4:  
gen rule4=0
* temp = min t-J and t-J+L period ahead
replace temp= minfut
drop minfut
* temp2 = min t-J and t-J+2L period ahead
foreach num of numlist $wind (-1)0 {
by new_id: replace temp2= F`num'.tempcost if temp==F`num'.tempcost
}
  

foreach num of numlist 1(1)$wind  {
replace rule4 =1 if temp== F`num'.temp2
}

replace regL$longwind  = temp if rule4==1 & regL$longwind ==.  

* step 5
replace regL$longwind = tempcost if regL$longwind ==.
  
**********************************
*Now do the next 7 periods
foreach per of numlist $runwind1 (-1)0 {
display `per'
gen minfut=.
gen maxfut=.
replace tempcost = L`per'.w_t

drop rule3 rule4

foreach num of numlist 0(1)$wind   {
replace var`num' = F`num'.tempcost
}

* step 0
local perold= `per'+1
replace regL`per' = regL`perold' if tempcost== regL`perold'

* step 1
replace regL`per' = tempcost if (tempcost< regL`perold') & regL`per'==.
 
* step 2
foreach num of numlist 1(1)$longwind  {
replace regL`per' = regL`perold' if ((regL`perold'  == F`num'.tempcost) & regL`per'==. )
}

* step 3
display `per'
gen rule3=0
foreach name of varlist var* { 
drop minfut maxfut
egen minfut = rmin(var*)
egen  maxfut = rmax(var*)
replace rule3=1 if `name'~= minfut & `name'~= maxfut 
}
drop maxfut
replace regL`per' = tempcost if rule3==1 & regL`per'==.

*rule 4
gen rule4=0
replace temp= minfut
drop minfut
foreach num of numlist $wind (-1)0 {
replace temp2= F`num'.tempcost if temp==F`num'.tempcost
}

foreach num of numlist 1(1)$wind  {
replace rule4 =1 if temp== F`num'.temp2
}
replace regL`per' = temp if rule4==1 & regL`per'==. & regL`perold'~=.


* step 5 
replace regL`per'= tempcost if regL`per'==.
}


gen w_r = regL0 if w_t~=.

drop regL* var* temp temp2 tempcost rule*


********************************************************************************
*********                     Draw here 20 sample                        *******
********************************************************************************
 
